/* Soma - Copyright (C) 2003-5 bakunin - Andrea Marchesini 
 *                                       <bakunin@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#else
# error Use configure; make; make install
#endif

#include "client.h"

code_str messages[] = {
  {GENERIC_ERROR, "Generic error.\n"}
  ,
  {PARAMETER_ERROR, "Parameter error.\nPlease, try --help\n"}
  ,
  {SOCKET_ERROR, "Socket error!\n"}
  ,
  {UNKNOW_HOST, "Error: unknow host.\n"}
  ,
  {CONNECT_ERROR, "Connect error.\n"}
  ,
  {PROTOCOL_ERROR, "Protocol error.\n"}
  ,
  {PASSWORD_ERROR, "Password error!\n"}
  ,
  {DONE, "Done.\n"}
  ,
  {INTERNAL_ERROR, "Internal error!!!\n"}
  ,
  {LOCK_ERROR, "Lock error.\n"}
  ,
  {YES_RUNNING, "Yes! Somad running.\n"}
  ,
  {NO_STOPPED, "No! Somad stopped\n"}
  ,
  {YES_NEXTSONG_SPOT, "Yes! NextSong mix with Spot.\n"}
  ,
  {NO_NEXTSONG_SPOT, "No! NextSong no mix with Spot.\n"}
  ,
  {0, NULL}
};

/* ECHO OFF */
void
echo_off (void)
{
  struct termios new;

  tcgetattr (0, &stored);

  new = stored;
  new.c_lflag &= (~ECHO);

  tcsetattr (0, TCSANOW, &new);
}

/* ECHO ON */
void
echo_on (void)
{
  tcsetattr (0, TCSANOW, &stored);
}

/* Fatal function. Write a message and quit. */
void
fatal (int code)
{
  if (set_code)
    fprintf (stdout, "%X\n", code);
  else
    fprintf (stdout, "%s", messages[code].str);

  exit (1);
}

/* Write a message */
void
message (int code)
{
  if (set_code)
    fprintf (stdout, "%X\n", code);
  else
    fprintf (stdout, "%s", messages[code].str);
}

/* Ask the password */
void
get_passwd (char *buff)
{
  int a;

  fprintf (stdout, "Soma's password: ");
  fflush (stdout);

  echo_off ();

  a = read (STDIN_FILENO, buff, 1024);
  buff[a - 1] = 0;

  echo_on ();

  fprintf (stdout, "\n");
}

/* EOF */
