/* soma - Copyright (C) 2004-5 bakunin - Andrea Marchesini 
 *                                 <bakunin@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#else
# error Use configure; make; make install
#endif

#include <stdio.h>
#include <string.h>

int
usage (void)
{
  fprintf (stderr, "Usage: soma-config [OPTIONS]\nOptions:\n");
  fprintf (stderr, "\t[--prefix]\n");
  fprintf (stderr, "\t[--version]\n");
  fprintf (stderr, "\t[--libs]\n");
  fprintf (stderr, "\t[--cflags]\n");
  fprintf (stderr, "\t[--ssl]\n");

  return 1;
}

int
main (int argc, char *argv[])
{
  register int i;

  if (argc < 2)
    return usage ();

  for (i = 1; i < argc; i++)
    {
      if (strcmp (argv[i], "--prefix") &&
	  strcmp (argv[i], "--version") &&
	  strcmp (argv[i], "--libs") &&
	  strcmp (argv[i], "--cflags") && 
	  strcmp (argv[i], "--ssl"))
	return usage ();
    }

  for (i = 1; i < argc; i++)
    {
      if (!strcmp (argv[i], "--prefix"))
	fprintf (stdout, "/usr");

      else if (!strcmp (argv[i], "--version"))
	fprintf (stdout, "2.1");

      else if (!strcmp (argv[i], "--libs"))
	fprintf (stdout, " -lxml2 -lz -lm  " " -lhistory -lreadline -lcurses -ldl -lpthread  -lssl -lcrypto -ldl  ");

      else if (!strcmp (argv[i], "--cflags"))
	fprintf (stdout, "-O2 -g -pipe -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fomit-frame-pointer -march=i586 -mtune=pentiumpro -fasynchronous-unwind-tables   -DSOMA_USE_OPENSSL -I/usr/include/libxml2   -Wall");

      else if (!strcmp (argv[i], "--ssl"))
#ifdef SOMA_USE_OPENSSL
	fprintf (stdout, "1")
#else
	fprintf (stdout, "0")
#endif
	  ;
    }

  fprintf (stdout, "\n");

  return 0;
}

/* EOF */
