/*
 * Soma - Copyright (C) 2003-5 bakunin - Andrea Marchesini
 * <bakunin@autistici.org>
 * 
 * This source code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 * 
 * This source code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. Please refer to the GNU Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Public License along with this
 * source code; if not, write to: Free Software Foundation, Inc., 675 Mass
 * Ave, Cambridge, MA 02139, USA.
 */

#ifndef __LIB_SOMA_H__
#define __LIB_SOMA_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <dirent.h>
#include <sys/param.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include "../include/code.h"
#include "../include/commons.h"
#include "../include/controller.h"
#include "../include/code.h"

#include "avcodec.h"
#include "avformat.h"

#define SIZE_BUFFER 1024

#define RETURN_VALUE(c, err, value) { \
  ((soma_controller *) c )->error= err ; \
  return value; \
}

struct __soma_socket_client
{
#ifdef SOMA_USE_OPENSSL
  SSL_CTX *ctx;
  SSL *ssl;
  SSL_METHOD *meth;
  X509 *server_cert;
#endif

  char buffer[SIZE_BUFFER];
  int fill;

  int fd;
};

int	__soma_get_line		(soma_controller * c,
				 struct __soma_socket_client *data,
				 char *buf);

int	__soma_get_line_fd	(int fd,
				 char *buf);

int	__soma_send_command	(soma_controller * c,
				 struct __soma_socket_client *data,
				 char *cmd);

size_t	__soma_write		(soma_controller * c,
				 struct __soma_socket_client *data,
				 char *buf,
				 size_t size);

size_t	__soma_read		(soma_controller * c,
				 struct __soma_socket_client *data,
				 char *buf,
				 size_t size);

void	__soma_close		(soma_controller * c,
				 struct __soma_socket_client *data);

int	__soma_socket		(soma_controller * c,
				 struct __soma_socket_client **);

int	__soma_generic		(soma_controller * c,
				 char *buf);

void	__soma_generic_list_free (char **);

#endif

/* EOF */
